<?

class NodeParser extends GenericParser {

 var $d_object;
 var $d_depType;
 var $d_nodecache;
 var $d_handleDependencies;

 function NodeParser($linkType) {
 parent::GenericParser();
 $this->d_object = false;
 $this->d_depType = $linkType;
 $this->d_handleDependencies = true;
 $this->d_nodecache = new NodeCache(0,$this->getParserKey());
 }

 function setBaseObject(&$object) {
 if (!is_object($object)) return;
 $this->d_object =& $object;
 reset($this->p_parser);
 while (list($key,$parser) = each($this->p_parser)) {
 $this->p_parser[$key]->setBaseObject($object);
 }
 }
 
 function &getBaseObject() {
 return $this->d_object;
 }

 function setHandleDependencies($val) {
 $this->d_handleDependencies = $val;
 reset($this->p_parser);
 while (list($key,$parser) = each($this->p_parser)) {
 $this->p_parser[$key]->setHandleDependencies($val);
 }
 }

 function doHandleDependencies() {
 return $this->d_handleDependencies;
 }
 
 function getDependencyType() {
 return $this->d_depType;
 }

 






 function clearEventMap( )
 {
 global $FEATURE;
 if (!$this->d_handleDependencies) return;
 removeEventDependencies( $this->d_object->getTType(), $this->d_object->getID(), 2, $this->d_depType );
 if ($FEATURE["nodecache"]) NodeCache::clearObjectLinks($this->d_object);
 }

 function cleanup() {
 NodeCache::cleanup();
 }

 function _initObjectParser(&$parser) {
 parent::_initObjectParser($parser);
 if (is_object($this->d_object)) $parser->setBaseObject($this->d_object);
 $parser->setDependencyType($this->d_depType);
 $parser->setNodeCache($this->d_nodecache);
 $parser->setHandleDependencies($this->d_handleDependencies);
 }

}

class NodeObjectParser extends ObjectParser {
 
 var $d_object;
 var $d_depType;
 var $d_nodecache;
 var $d_handleDependencies;
 
 function NodeObjectParser() {
 parent::ObjectParser();
 $this->d_object = false;
 $this->d_depType = LINKT_PARSER;
 $this->d_nodecache = false;
 $this->d_handleDependencies = true;
 }
 
 function addDependency( $objectType, $objectID, $onEvent, $ignoreEvent = 0) {
 global $FEATURE;
 if (!$this->d_handleDependencies) return;
 if (!$this->useCache() || !$FEATURE["nodecache"] || !is_object($this->d_nodecache)) {
 if (is_object($this->d_object)) addEventDependency( $objectType, $objectID, $onEvent, $this->d_object->getTType(), $this->d_object->getID(), $this->d_depType, $ignoreEvent );
 } else {
 $this->d_nodecache->addDependency($objectType,$objectID, $onEvent, $ignoreEvent);
 }
 }

 function setBaseObject(&$object) {
 $this->d_object =& $object;
 }

 function &getBaseObject() {
 return $this->d_object;
 }

 function setDependencyType($linkType) {
 $this->d_depType = $linkType;
 }
 
 function getDependencyType() {
 return $this->d_depType;
 }

 function setNodeCache(&$cache) {
 $this->d_nodecache =& $cache;
 }

 function setHandleDependencies($val) {
 $this->d_handleDependencies = $val;
 }

 function doHandleDependencies() {
 return $this->d_handleDependencies;
 }
 
 function parse($code, $props, $nocache = false) {
 global $FEATURE;
 $parser =& $this->getParser();
 if ($FEATURE["nodecache"] && $parser->doEvaluate() && $this->useCache() && is_object($this->d_nodecache)) {
 
 
 $this->d_nodecache->setInput($this->getType(), $this->getKeyname(), $code, $props, $this->getCacheKey());
 if ($this->d_nodecache->isCached() && !$nocache) {
 $ret = $this->d_nodecache->getOutput();
 } else {
 $this->d_nodecache->clearCacheDependencies();
 $ret = $this->_parse($code, $props);
 $this->d_nodecache->setOutput($ret);
 }
 $this->d_nodecache->linkToObject($this->d_object, $this->d_depType);
 return $ret;
 } else {
 $ret = $this->_parse($code, $props);
 return $ret; 
 }
 }

 function useCache() { return false; }

 function _parse($code, $props) { return new NodeException("Parser not implemented yet."); }

 function getCacheKey() { return false; }

}

?>
