<?php




function get_files_filter($folder_id = 0, $folders = array(), $search = '', $ires = array(), $filter='file', $channel_id = 0) {

 global $FOLDER_ID, $FEATURE, $SQLAS, $NODE_ID;

 
 if ( $folders !== false && !$folder_id && !$FOLDER_ID && (!is_array($folders) || count($folders) == 0) ) {
 warning(7,'cn:get_files_filter: No Folder id and no array of Folder ids');
 return array();
 }

 
 if ($channel_id !== false) {
 $sql_filter = "contentfile.channel_id = ".sqlf_tl_num($channel_id)." AND ";
 } else {
 $sql_filter = "";
 }
 if ($filter == 'image') {
 $sql_filter .= "LOWER(contentfile.filetype) LIKE 'image%'";
 } else if ($filter == 'file') {
 $sql_filter .= "LOWER(contentfile.filetype) NOT LIKE 'image%'";
 }

 
 if ( is_array($folders) && count($folders) > 0) {
 $folder = "AND contentfile.folder_id IN (".implode(",",sqlf_tl_num_array($folders)).")";
 } else if ($folders !== false) {
 if (!$folder_id) {
 $folder_id = $FOLDER_ID;
 }
 $folder = "AND contentfile.folder_id = ".sqlf_tl_num($folder_id);
 } else {
 $folder = "";
 }
 
 




 $sql = "SELECT DISTINCT contentfile.name, contentfile.description, contentfile.id, contentfile.filetype, 
	contentfile.filesize, folder.name AS folder, contentfile.cdate, contentfile.edate, 
	euser.firstname AS e_firstname, euser.lastname AS e_lastname, cuser.firstname AS c_firstname, 
	cuser.lastname AS c_lastname ".$ires["select"].", contentfile.dpix, contentfile.dpiy, contentfile.sizex,
	contentfile.sizey, contentfile.folder_id, contentfile.folder_id as parentobjectid, 10002 as parentobjecttype";

 if ($NODE_ID > 0) {
 $sql .= ", IF(contentfile_online.node_id IS NULL, 0, 1) online";
 }

 $sql .= " FROM contentfile 
	LEFT JOIN systemuser $SQLAS cuser ON contentfile.creator = cuser.id 
	LEFT JOIN systemuser $SQLAS euser ON contentfile.editor = euser.id
	LEFT JOIN folder ON folder.id = contentfile.folder_id 
	LEFT JOIN contentfile_online ON contentfile.id = contentfile_online.contentfile_id";

 if ($NODE_ID > 0) {
 $sql .= " AND contentfile_online.node_id = " . $NODE_ID;
 }

 $sql .= " WHERE $sql_filter $folder $search ".$ires["orderby"];

 $rs = query($sql);
 
 return $rs['arr'];
 
}

function get_files($folder_id = 0, $folders = array(), $search = '', $ires = array(), $channel_id = 0) {
 return get_files_filter($folder_id, $folders, $search, $ires, 'file', $channel_id);
}

function get_images($folder_id = 0, $folders = array(), $search = '', $ires = array(), $channel_id = 0) {
 return get_files_filter($folder_id, $folders, $search, $ires, 'image', $channel_id);
}
















function getFilesOrImagesFromRestApi($folderId, $channelId = null, $type, $usageInfo = null, $keyMapper = null,
 $sortBy = "name", $sortOrder = "asc", $skipCount = 0, $maxItems = -1, $parameters = array())
{
 $requestParameters = $parameters;
 $restPath = "rest";

 if ($channelId === null) {
 $channelId = $GLOBALS['NODE_ID'];
 }
 $requestParameters['nodeId'] = $channelId;

 
 

 if (is_array($usageInfo)) {
 $usageType = $usageInfo['type'];
 $usageObjects = $usageInfo['objects'];

 if ($usageType == T_PAGE) {
 $restPath .= "/page/usage";
 } else if ($usageType == T_IMAGE) {
 $restPath .= "/image/usage";
 } else if ($usageType == T_FILE) {
 $restPath .= "/file/usage";
 }
 
 $restPath .= "/" . ($type === T_IMAGE ? "image" : "file");
 } else {
 if ($type === T_IMAGE) {
 $restPath .= "/folder/getImages";
 } else {
 $restPath .= "/folder/getFiles";
 }

 $restPath .= "/" . $folderId;
 }

 $url = $GLOBALS['CN_LOCAL_SERVER'] . $GLOBALS['PORTLETAPP_PREFIX_INTERNAL']. $restPath;

 $requestParameters['nodeId'] = $NODE_ID;
 $requestParameters['sortby'] = $sortBy;
 $requestParameters['sortorder'] = $sortOrder;
 
 $requestParameters['skipCount'] = $skipCount;
 
 $requestParameters['maxItems'] = $maxItems;
 $requestParameters['sid'] = $GLOBALS['SESSION_TOKEN'];
 
 
 $url .= "?" . http_build_query($requestParameters);

 if (is_array($usageInfo['objects'])) {
 
 
 while (list($key, $val) = each($usageInfo['objects'])) {
 $url .= "&id=" . $key;
 }
 }

 $fetchCurl = new fetchCurl();
 $fetchCurl->setUrl($url);
 $responseBody = $fetchCurl->doRequest();

 
 $returnCode = $fetchCurl->getReturnCode();
 if (empty($returnCode)) {
 halt(7,'Unable to connect to CNPortletapp for getting list data via {' . $url . '}');
 } else if ($returnCode >= 400) {
 halt(120, 'Accessing CNPortletapp returned error ' . $fetchCurl->getReturnCode());
 }

 $objects = json_decode($responseBody, true);

 $total = $objects["numItems"];
 $objects = $objects["files"];

 if (is_array($objects)) {
 
 if ($keyMapper) {
 $objects = $keyMapper->remap($objects);
 }

 reset($objects);
 }

 
 if ($skipCount > 0) {
 $objects = array_pad($objects, -count($objects) - $skipCount, null);
 }

 if ($total > count($objects)) {
 $objects = array_pad($objects, $total, null);
 }

 return $objects;
}
