<?php











class wsdlcache {
 



 var $fplock;
 



 var $cache_lifetime;
 



 var $cache_dir;
 



 var $debug_str = '';

 






 function wsdlcache($cache_dir='.', $cache_lifetime=0) {
 $this->fplock = array();
 $this->cache_dir = $cache_dir != '' ? $cache_dir : '.';
 $this->cache_lifetime = $cache_lifetime;
 }

 






 function createFilename($wsdl) {
 return $this->cache_dir.'/wsdlcache-' . md5($wsdl);
 }

 





 function debug($string){
 $this->debug_str .= get_class($this).": $string\n";
 }

 






 function get($wsdl) {
 $filename = $this->createFilename($wsdl);
 if ($this->obtainMutex($filename, "r")) {
 
 if ($this->cache_lifetime > 0) {
 if (file_exists($filename) && (time() - filemtime($filename) > $this->cache_lifetime)) {
 unlink($filename);
 $this->debug("Expired $wsdl ($filename) from cache");
 $this->releaseMutex($filename);
 return null;
 }
 }
 
 $fp = @fopen($filename, "r");
 if ($fp) {
 $s = implode("", @file($filename));
 fclose($fp);
 $this->debug("Got $wsdl ($filename) from cache");
 } else {
 $s = null;
 $this->debug("$wsdl ($filename) not in cache");
 }
 $this->releaseMutex($filename);
 return (!is_null($s)) ? unserialize($s) : null;
 } else {
 $this->debug("Unable to obtain mutex for $filename in get");
 }
 return null;
 }

 







 function obtainMutex($filename, $mode) {
 if (isset($this->fplock[md5($filename)])) {
 $this->debug("Lock for $filename already exists");
 return false;
 }
 $this->fplock[md5($filename)] = fopen($filename.".lock", "w");
 if ($mode == "r") {
 return flock($this->fplock[md5($filename)], LOCK_SH);
 } else {
 return flock($this->fplock[md5($filename)], LOCK_EX);
 }
 }

 






 function put($wsdl_instance) {
 $filename = $this->createFilename($wsdl_instance->wsdl);
 $s = serialize($wsdl_instance);
 if ($this->obtainMutex($filename, "w")) {
 $fp = fopen($filename, "w");
 fputs($fp, $s);
 fclose($fp);
 $this->debug("Put $wsdl_instance->wsdl ($filename) in cache");
 $this->releaseMutex($filename);
 return true;
 } else {
 $this->debug("Unable to obtain mutex for $filename in put");
 }
 return false;
 }

 






 function releaseMutex($filename) {
 $ret = flock($this->fplock[md5($filename)], LOCK_UN);
 fclose($this->fplock[md5($filename)]);
 unset($this->fplock[md5($filename)]);
 if (! $ret) {
 $this->debug("Not able to release lock for $filename");
 }
 return $ret;
 }

 






 function remove($wsdl) {
 $filename = $this->createFilename($wsdl);
 
 $this->obtainMutex($filename, "w");
 $ret = unlink($filename);
 $this->debug("Removed ($ret) $wsdl ($filename) from cache");
 $this->releaseMutex($filename);
 return $ret;
 }
}
?>
